

#import "#_lib_FFT.ex4"
void realfastfouriertransform(double& a[], int tnn, bool inversefft);
#import

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_level1 0.0

double Buffer1[];
double Up[];
double Down[];
double Fmin;
double Fmax;
extern int n=8;
extern double Alpha = 0.07;
extern bool Color_Hist=true;
int CountBars=300;
double aa[];
int N;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  IndicatorBuffers(3);
 IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
if(Color_Hist==true){
 SetIndexStyle(0,DRAW_HISTOGRAM,0,4);
 SetIndexStyle(1,DRAW_HISTOGRAM,0,4);
 SetIndexBuffer(0,Up);
SetIndexBuffer(1,Down);
SetIndexBuffer(2,Buffer1);
SetIndexStyle(2,DRAW_NONE);
}
else{
SetIndexBuffer(1,Buffer1);
SetIndexStyle(1,DRAW_LINE,0,2);

}

//---
  
   SetIndexDrawBegin(0,Bars-CountBars);
  ArraySetAsSeries(Buffer1, TRUE);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   N=MathPow(2,n);
 ArrayResize(aa,N);

int counted_bars = IndicatorCounted(),limit,i;
      if(counted_bars > 0) 
        counted_bars--;
  limit = Bars - CountBars;
 for( i=limit; i>=0; i--) 
   { 
      aa[i]=iClose(Symbol(),0,i); 
      }
       for( i=limit; i>=0; i--) 
   {
      Fmax=iCustom(Symbol(),0,"CyclePeriod",Alpha,0,i);
      }
      for( i=limit; i>=0; i--) 
   {
      Fmin=iCustom(Symbol(),0,"CyclePeriod",Alpha,0,i)/2;
   }
   //---
   InSigNormalize(aa);
   realfastfouriertransform(aa,N, false);
   
   N=ArraySize(aa);
  for( i=limit; i>=0; i--)  

   { 
      if( 
          (i<Fmin || i>Fmax) 
          
        ) {
         aa[i]=0.0;
          }
      
   }
   //---
   realfastfouriertransform(aa, N, true);
   for( i=limit; i>=0; i--) 
   {
      Buffer1[i]=aa[i];
}
  for( i=limit; i>=0; i--) 
   {
      Up[i]=0;
      Down[i]=0;
   if (Buffer1[i]>Buffer1[i+1]){
   Up[i]=Buffer1[i];
   Up[i+1]=Buffer1[i+1];
   }
   else if (Buffer1[i]<Buffer1[i+1]){
   Down[i]=Buffer1[i];
    Down[i+1]=Buffer1[i+1];
   }
   }
    return(0);
  }
//-------------------------------------------------------------------+

//--------------------------------------------------------------------+
void InSigNormalize(double& aa[])
{
   double sum_sqrt;
   int element_count=ArraySize(aa);
   sum_sqrt=0;
   for( int i=0; i<=element_count-1; i++)
   {
      sum_sqrt+=MathPow(aa[i],2);
   }
   sum_sqrt=MathSqrt(sum_sqrt);
   
   if (sum_sqrt!=0)
   {
      for( i=0; i<=element_count-1; i++)
      {
         aa[i]=aa[i]/sum_sqrt;
      }
   }
   return;
}